package com.ustadmobile.core.db.dao

import com.ustadmobile.door.DoorDataSourceFactory
import com.ustadmobile.door.DoorDatabase
import com.ustadmobile.door.ext.doorPrimaryKeyManager
import com.ustadmobile.door.ext.rootDatabase
import com.ustadmobile.door.util.systemTimeInMillis
import com.ustadmobile.lib.db.entities.CourseTerminology
import kotlin.IllegalStateException
import kotlin.Int
import kotlin.Long
import kotlin.Unit
import kotlin.collections.List

public class CourseTerminologyDao_ReplicateWrapper(
  private val _db: DoorDatabase,
  private val _dao: CourseTerminologyDao
) : CourseTerminologyDao() {
  public override suspend fun replicateOnNewNode(newNodeId: Long): Unit {
    _dao.replicateOnNewNode(newNodeId)
  }

  public override suspend fun replicateOnChange(): Unit {
    _dao.replicateOnChange()
  }

  public override fun findAllCourseTerminology(): DoorDataSourceFactory<Int, CourseTerminology> =
      _dao.findAllCourseTerminology()

  public override fun findAllCourseTerminologyList(): List<CourseTerminology> = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override suspend fun getTerminologyForClazz(clazzUid: Long): CourseTerminology? =
      _dao.getTerminologyForClazz(clazzUid)

  public override suspend fun findByUidAsync(uid: Long): CourseTerminology? =
      _dao.findByUidAsync(uid)

  public override suspend fun updateAsync(entity: CourseTerminology): Int {
    entity.ctLct = systemTimeInMillis()
    //must set versionid and/or primary key here
    return _dao.updateAsync(entity)
  }

  public override fun insert(entity: CourseTerminology): Long = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override suspend fun insertAsync(entity: CourseTerminology): Long {
    val _pkManager = _db.rootDatabase.doorPrimaryKeyManager
    if(entity.ctUid == 0L) {
      val _newPk = _pkManager.nextIdAsync(450)
      entity.ctUid = _newPk
    }
    entity.ctLct = systemTimeInMillis()
    //must set versionid and/or primary key here
    _dao.insertAsync(entity)
    return entity.ctUid
  }

  public override fun insertList(entityList: List<out CourseTerminology>): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override fun updateList(entityList: List<out CourseTerminology>): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")

  public override fun update(entity: CourseTerminology): Unit = throw
      IllegalStateException("Synchronous db access is NOT possible on Javascript!")
}
